program VelModel1

  use sep
  implicit none

  integer              :: n1,n2,n3
  real                 :: d1,d2,d3
  real                 :: o1,o2,o3

  real,allocatable     :: model(:,:,:)

  integer              :: ii,jj,kk

  ! Grid
  n1=301
  n2=1201
  n3= 1
  d1= 2.
  d2= 2.
  d3= 2.
  o1= 0.
  o2= 0.
  o3= 0.

  ! Header I/O
  call sep_init()

  call to_history("n1",n1)
  call to_history("n2",n2)
  call to_history("n3",n3)

  call to_history("d1",d1)
  call to_history("d2",d2)
  call to_history("d3",d3)

  call to_history("o1",o1)
  call to_history("o2",o2)
  call to_history("o3",o3)

  call sep_close

  ! Allocate
  allocate(model(n1,n2,n3))


  !!! Build Actual model
  do kk=1,n3
  do jj=1,n2
  do ii=1,n1
    model(ii,jj,kk) = 1500.
    
    if ((real(ii)-real(jj)/(n2-1)*100.).gt. 50.) then; model(ii,jj,kk)=2500.; end if

    if ( real(ii)-40.*exp(-(real(jj-(n2-1)/2)/50.)**2.).gt.175) then; model(ii,jj,kk)=2000.; end if

    if ( ii              .gt.250) then; model(ii,jj,kk)=3000.; end if

  end do
  end do
  end do


  ! Write model to file
  call srite("out",model,4*size(model))

  ! Deallocate and exit
  deallocate(model)
  call exit()

end program
