program WEfilter

  use sep
  implicit none

  integer :: ii,jj,kk,ll
  integer :: n1,n2,n3
  real    :: d1,d2,d3
  real    :: o1,o2,o3
  integer :: j1,j2

  real, allocatable :: datain(:,:,:),dxdx(:,:,:),dydy(:,:,:),dtdt(:,:,:),dxdxdydy(:,:,:),v(:,:,:),s(:,:,:)

  call sep_init()

  call from_history('n1',n1,1 )
  call from_history('n2',n2,1 )
  call from_history('n3',n3,1 )
  
  call from_history('d1',d1,1.)
  call from_history('d2',d2,1.)
  call from_history('d3',d3,1.)
  
  call from_history('o1',o1,0.)
  call from_history('o2',o2,0.)
  call from_history('o3',o3,0.)
  
  call from_param('j1',j1,1)
  call from_param('j2',j2,1)

!  call to_history('n4',5 )
!  call to_history('d4',1.)
!  call to_history('o4',0.)
!  call to_history('label4','(dxdx,dydy,dxdx+dydy,dtdt,v)')

  if (exist_file("dxdx")) then
    call to_history('n1',n1,'dxdx')
    call to_history('n2',n2,'dxdx')
    call to_history('o1',o1,'dxdx')
    call to_history('o2',o2,'dxdx')
    call to_history('d1',d1,'dxdx')
    call to_history('d2',d2,'dxdx')
    call to_history('n3',n3,'dxdx')
    call to_history('d3',d3,'dxdx')
    call to_history('o3',o3,'dxdx')
    call to_history('n4',1 ,'dxdx')
    call to_history('d4',1.,'dxdx')
    call to_history('o4',0.,'dxdx')
  end if

  if (exist_file("dydy")) then
    call to_history('n1',n1,'dydy')
    call to_history('n2',n2,'dydy')
    call to_history('o1',o1,'dydy')
    call to_history('o2',o2,'dydy')
    call to_history('d1',d1,'dydy')
    call to_history('d2',d2,'dydy')
    call to_history('n3',n3,'dydy')
    call to_history('d3',d3,'dydy')
    call to_history('o3',o3,'dydy')
    call to_history('n4',1 ,'dydy')
    call to_history('d4',1.,'dydy')
    call to_history('o4',0.,'dydy')
  end if

  if (exist_file("dxdxdydy")) then
    call to_history('n1',n1,'dxdxdydy')
    call to_history('n2',n2,'dxdxdydy')
    call to_history('o1',o1,'dxdxdydy')
    call to_history('o2',o2,'dxdxdydy')
    call to_history('d1',d1,'dxdxdydy')
    call to_history('d2',d2,'dxdxdydy')
    call to_history('n3',n3,'dxdxdydy')
    call to_history('d3',d3,'dxdxdydy')
    call to_history('o3',o3,'dxdxdydy')
    call to_history('n4',1 ,'dxdxdydy')
    call to_history('d4',1.,'dxdxdydy')
    call to_history('o4',0.,'dxdxdydy')
  end if

  if (exist_file("dtdt")) then
    call to_history('n1',n1,'dtdt')
    call to_history('n2',n2,'dtdt')
    call to_history('o1',o1,'dtdt')
    call to_history('o2',o2,'dtdt')
    call to_history('d1',d1,'dtdt')
    call to_history('d2',d2,'dtdt')
    call to_history('n3',n3,'dtdt')
    call to_history('d3',d3,'dtdt')
    call to_history('o3',o3,'dtdt')
    call to_history('n4',1 ,'dtdt')
    call to_history('d4',1.,'dtdt')
    call to_history('o4',0.,'dtdt')
  end if
  if (exist_file("v")) then
    call to_history('n1',n1,'v')
    call to_history('n2',n2,'v')
    call to_history('o1',o1,'v')
    call to_history('o2',o2,'v')
    call to_history('d1',d1,'v')
    call to_history('d2',d2,'v')
    call to_history('n3',n3,'v')
    call to_history('d3',d3,'v')
    call to_history('o3',o3,'v')
    call to_history('n4',1 ,'v')
    call to_history('d4',1.,'v')
    call to_history('o4',0.,'v')
  end if
  if (exist_file("s")) then
    call to_history('n1',n1,'s')
    call to_history('n2',n2,'s')
    call to_history('o1',o1,'s')
    call to_history('o2',o2,'s')
    call to_history('d1',d1,'s')
    call to_history('d2',d2,'s')
    call to_history('n3',n3,'s')
    call to_history('d3',d3,'s')
    call to_history('o3',o3,'s')
    call to_history('n4',1 ,'s')
    call to_history('d4',1.,'s')
    call to_history('o4',0.,'s')
  end if
  
  call sep_close()
  
  allocate(datain(n1,n2,n3),dxdx(n1,n2,n3),dydy(n1,n2,n3),dxdxdydy(n1,n2,n3),dtdt(n1,n2,n3),v(n1,n2,n3),s(n1,n2,n3));
  datain=0.;dxdx=0.;dydy=0.;dxdxdydy=0.;dtdt=0.;v=0.
  
  do kk=1,n3
    call sreed('in',datain(:,:,kk),4*n1*n2)
  end do
  
  do ii=2,n1-1
  do jj=2,n2-1
  do kk=2,n3-1
    
    dxdx    (ii,jj,kk)=(datain(ii+1,jj,kk)-2*datain(ii,jj,kk)+datain(ii-1,jj,kk))/d1/d1
    dydy    (ii,jj,kk)=(datain(ii,jj+1,kk)-2*datain(ii,jj,kk)+datain(ii,jj-1,kk))/d2/d2
    dxdxdydy(ii,jj,kk)=dxdx(ii,jj,kk)+dydy(ii,jj,kk)
    dtdt    (ii,jj,kk)=(datain(ii,jj,kk+1)-2*datain(ii,jj,kk)+datain(ii,jj,kk-1))/d3/d3
    v       (ii,jj,kk)=sqrt(dtdt(ii,jj,kk)/dxdxdydy(ii,jj,kk))
    s       (ii,jj,kk)=sqrt(dxdxdydy(ii,jj,kk)/dtdt(ii,jj,kk))
    if (v(ii,jj,kk).lt.0.) then
      v(ii,jj,kk)=0.
    else
      v(ii,jj,kk)=log(v(ii,jj,kk))
    end if
    if (s(ii,jj,kk).lt.0.) then
      s(ii,jj,kk)=0.
    else
      s(ii,jj,kk)=log(s(ii,jj,kk))
    end if
    
  end do
  end do
  end do
  
  
  if (exist_file("dxdx")) then
    do kk=1,n3
      call srite('dxdx'    ,dxdx(:,:,kk)    ,4*n1*n2)
    end do
  end if
  if (exist_file("dydy")) then
    do kk=1,n3
      call srite('dydy'    ,dydy(:,:,kk)    ,4*n1*n2)
    end do
  end if
  if (exist_file("dxdxdydy")) then
    do kk=1,n3
      call srite('dxdxdydy',dxdxdydy(:,:,kk),4*n1*n2)
    end do
  end if
  if (exist_file("dtdt")) then
    do kk=1,n3
      call srite('dtdt'    ,dtdt(:,:,kk)    ,4*n1*n2)
    end do
  end if
  if (exist_file("v")) then
    do kk=1,n3
      call srite('v'       ,v(:,:,kk)       ,4*n1*n2)
    end do
  end if
  if (exist_file("s")) then
    do kk=1,n3
      call srite('s'       ,s(:,:,kk)       ,4*n1*n2)
    end do
  end if
  
  deallocate(datain,dxdx,dydy,dxdxdydy,dtdt,v,s)
  call exit()

end program
